routes/web.php
<?php

use App\Http\Controllers\CommentController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\VideoController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/home', function () {
    return redirect('/');
});


Route::get('/', [HomeController::class, 'index']);
Route::get('/imagendefaulttvideo' , [HomeController::class, 'imgDefault']);
Route::get('/imagendevideo/{path}' , [HomeController::class, 'miniatura']);
Route::get('/videocrs/{path}' , [HomeController::class, 'video'])->name('videocrs');

Route::post('/comment', [CommentController::class,'store'])->name('comment');


Auth::routes();



Route::resource('video' , VideoController::class ,['except' => [
    'show'
]])->middleware(['auth']);

Route::resource('video' , VideoController::class ,['only' => [
    'show'
]]);

app/Models/Video.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Video extends Model
{
    //use HasFactory;

    protected $table = "video";

    
    public function comments(){
        return $this->hasMany(Comment::class , 'video_id' );
    }
    public function user(){
        return $this->belongsTo(User::class , 'users_id');
    }
}

app/Http/Controllers/VideoController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Models\Video;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;
use Symfony\Component\HttpFoundation\Response;




class VideoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $VideoUsuario = Video::where('users_id', '=' , Auth::user()->id )->orderBy('created_at', 'desc')->paginate(6);

        return view('video.indexVideo' ,  array('videos' => $VideoUsuario));
    }

    

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('video.createVideo');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validacion = $request->validate([
            'Titulo' => 'required|max:120',
            'Miniatura' => 'required|mimes:jpg,png',
            'Video' => 'required|mimetypes:video/avi,video/mpeg,video/mp4'
        ]);

        
        
        $video  = new Video();
        $user   = Auth::user();
        $titulo = $request->Titulo;

        $video->users_id    = $user->id;
        $video->title       = $titulo; 
        $video->descriotion = $request->Descripcion;
        
        $imagenFile = $request->file('Miniatura');
        $pathImagen = str_replace( array("@" , ".") , '_' , $user->email) . "_" . str_replace(" " , "_" , $titulo ) . "_" . uniqid() . ".". $imagenFile->getClientOriginalExtension();
        Storage::disk('imagen')->put($pathImagen, file_get_contents($imagenFile));

        $videofile = $request->file('Video');
        $pathVideo =  str_replace( array("@" , ".") , '_' , $user->email) . "_" . str_replace(" " , "_" , $titulo ) . "_" . uniqid() . ".". $videofile->getClientOriginalExtension();
        Storage::disk('videos')->put($pathVideo, file_get_contents($videofile));

        $video->video  = $pathVideo;
        $video->imagen = $pathImagen;

        $video->save();

        return redirect('/');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
       
        $video = Video::find($id);
        $comment = $video->comments;

        return view('video.showVideo' , array('video' => $video ) );
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $video = Video::find($id);
        return view('video.editVideo' , array('video' => $video) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        
        $video  = Video::find($id);
        $user = Auth::user();
        if($video->users_id != Auth::user()->id){
            $error = array('style' => 'alert-danger' , 'msg' => 'Error al modificar video');
            $VideoUsuario = Video::where('users_id', '=' , Auth::user()->id )->orderBy('created_at', 'desc')->paginate(6);

            return view('video.indexVideo' ,  array('videos' => $VideoUsuario , 'error' => $error));
        }

        $validacion = $request->validate([
            'Titulo' => 'max:120',
            'Miniatura' => 'mimes:jpg,png',
            'Video' => 'mimetypes:video/avi,video/mpeg,video/mp4'
        ]);

        $video->title = $request->Titulo ? $request->Titulo : $video->title;
        $video->descriotion = $request->Descripcion ? $request->Descripcion : $video->descriotion;

        $imagenFile = $request->file('Miniatura');
        if($imagenFile){
            $pathImagen = str_replace( array("@" , ".") , '_' , $user->email) . "_" . str_replace(" " , "_" , $video->title ) . "_" . uniqid() . ".". $imagenFile->getClientOriginalExtension();
            Storage::disk('imagen')->put($pathImagen, file_get_contents($imagenFile)); 
            $video->imagen = $pathImagen;
        }
        

        $videofile = $request->file('Video');
        
        if($videofile){
            $pathVideo =  str_replace( array("@" , ".") , '_' , $user->email) . "_" . str_replace(" " , "_" , $video->title ) . "_" . uniqid() . ".". $videofile->getClientOriginalExtension();
            Storage::disk('videos')->put($pathVideo, file_get_contents($videofile));
            $video->video  = $pathVideo;
        }        

        $video->save();
        
        $error = array('style' => 'alert-success' , 'msg' => 'Video Editado');
        return view('video.showVideo' , array('video' => $video , 'error' => $error ) );

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

}

resources/views/video/createVideo.blade.php
@extends('layouts.app')



@section('content')




<div class="container">
    <div class="row">
        <h2>Crear video</h2>

        <form action="{{url('/video')}}" enctype="multipart/form-data" class="col-lg-7" method="post">
            
            @csrf

            @if($errors->any())
                
            <div class="alert alert-danger">
                <ul>
                    @foreach($errors->all() as $error)
                        <li>{{$error}}</li>
                    @endforeach
                </ul>
            </div>

            @endif

            <div class="form-group">
              <label for="Titulo">Titulo</label>
              <input type="text" name="Titulo" id="Titulo" class="form-control" placeholder="Titulo del Video">
            </div>

            <div class="form-group">
              <label for="Descripcion">Descripción</label>
              <textarea class="form-control" name="Descripcion" id="Descripcion"></textarea>
            </div>


            <div class="form-group">
                <label for="Miniatura">Miniatura</label>
                <input type="file" name="Miniatura" id="Miniatura" class="form-control"  >
            </div>

            <div class="form-group">
                <label for="Video">Video</label>
                <input type="file" name="Video" id="Video" class="form-control"  >
            </div>

            <br>
            
            <button type="submit" class="btn btn-primary">Subir Video</button>

        </form>

    </div>
</div>



</div>

@endsection

resources/views/video/editVideo.blade.php
@extends('layouts.app')



@section('content')




<div class="container">
    <div class="row">
        <h2>Crear video</h2>

        <form action="{{route('video.update', ['video' => $video->id ]) }}" enctype="multipart/form-data" class="col-lg-7" method="POST">
            @method('PUT')
            @csrf
            
            @if($errors->any())
                
            <div class="alert alert-danger">
                <ul>
                    @foreach($errors->all() as $error)
                        <li>{{$error}}</li>
                    @endforeach
                </ul>
            </div>

            @endif


            

            <div class="form-group">
              <label for="Titulo">Titulo</label>
              <input type="text" name="Titulo" id="Titulo" class="form-control" placeholder="Titulo del Video" @if(isset($video)) value="{{$video->title}}"  @endif>
            </div>

            <div class="form-group">
              <label for="Descripcion">Descripción</label>
              <textarea class="form-control" name="Descripcion" id="Descripcion">@if(isset($video )) {{$video->descriotion}}  @endif</textarea>
            </div>

            <div class="row">
                <div class="col-sm-6">
                    <div class="form-group">
                        <label for="Miniatura">Miniatura</label>
                        <input type="file" name="Miniatura" id="Miniatura" class="form-control">
                        <br>
                        <img src="{{url('imagendevideo/'  .  $video->imagen)}}" class="img-fluid rounded-start ">
                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="form-group">
                        <label for="Video">Video</label>
                        <input type="file" name="Video" id="Video" class="form-control"  >
                        <br>
                        <div  class=" embed-responsive embed-responsive-21by9">
                            <video  id="video" autoplay  controls='true'>
                                <source  src="{{ route('videocrs' , ['path' => $video->video ])}}" >
                            </video>
                        </div>
                    </div>
                </div>
            </div>
            <br>
            
            <button type="submit" class="btn btn-primary">Editar Video</button>

        </form>

    </div>
</div>



</div>

@endsection

resources/views/video/indexVideo.blade.php
@extends('layouts.app')

@section('content')

<div class="container">


    @if(isset($error))
    <div class="alert {{$error['style']}}" role="alert">
        {{$error['msg']}}
    </div>

    @endif

    <h4>Videos subidos</h4>

    <hr>

    @if($videos->count() <= 0 )
        <div class="alert alert-warning" >
            <h4 class="alert-heading">No tienes videos!</h4>
            <p>ingresa al formulario para subir videos en la plataforma</p>
            <hr>
            <a class="btn btn-warning" href="{{url('video/create')}}" role="button">Subir video</a>
        </div>
    @endif

    @foreach ($videos as $video)
     
    <div class="card mt-4">
        
        <div class="card-body">
            <div class="row">
                <div class="col-md-4 img-card-list">

                    <div class="img-card d-flex justify-content-center " style="object-fit: cover;">
                        <img src="{{url('imagendevideo/'  .  $video->imagen)}}" class="img-fluid rounded-start ">
                    </div>
                    
                </div>
                <div class="col-md-8 ">
                    <div class="d-flex align-self-stretch flex-column ">
                        <h4 class="card-title p-2">{{$video->title}}</h4>
                        <p class="card-text p-2">{{$video->descriotion}}</p>
                        <div class="mt-auto p-2" >
                            <a href="#" class="btn btn-primary">Eliminar</a>
                            <a href="{{url('/video/'.$video->id.'/edit')}}" class="btn btn-primary">Editar</a>
                            <a href="{{url('/video/'.$video->id)}} " class="btn btn-primary">Ver video</a>
                        </div>
                    </div>
                    
                </div>
            </div>
        </div>
         
    </div>

    @endforeach

   
    <br>
    {{$videos->links()}}

</div>


@endsection

resources/views/video/showVideo.blade.php
@extends('layouts.app')

@section('content')

<div class="container">

    @if(isset($error))
    <div class="alert {{$error['style']}}" role="alert">
        {{$error['msg']}}
    </div>
    @endif

    <div class="row">
        <div class="col-md-12">
            <div  class=" embed-responsive embed-responsive-21by9">
                <video  id="video" autoplay  controls='true'>
                    <source  src="{{ route('videocrs' , ['path' => $video->video ])}}" >
                </video>
            </div>

            <br>

            <h4>{{$video->title}}</h4>
            <p>{{$video->user->name}} <small>{{FormatTime::LongTimeFilter($video->created_at)}}</small></p>
           
        </div>
    </div>



    
    <div class="row">
        
        
        @if(is_null($video->descriotion))
        
        <p>No tiene descripción</p>

        @else
        <p>
        <button class="btn btn-primary" type="button" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
            Descripción
        </button>
        </p>
        <div class="collapse" id="collapseExample">
            <div class="card card-body">
              {{$video->descriotion}}
            </div>
        </div>

        @endif
        
    </div>
    <hr>
    <br>

    <div class="row">
            
         @include('../comment/commentImput')
        
    </div>

</div>






@endsection